/**
 * 
 */
package com.lombardisoftware.gwtcommon.client;

import java.util.List;

import com.google.gwt.user.client.ui.FlowPanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * @author jsugg
 *
 */
public abstract class AbstractDetailsPanel extends AbstractListPanel {
    private PipesMenu pipesMenu;

    /**
     * Set the current object this details panel should display.
     * @param theObject  the current object
     */
    //protected abstract void setCurrentObject(AbstractClientObject theObject);

    protected Widget getTitleWidget() {
        FlowPanel proTitle = new FlowPanel();
        proTitle.setStyleName("proTitle");
        
        Widget crumbs = createCrumbs();
        if (crumbs != null)
            proTitle.add(crumbs);

        Widget pipes = createPipes();
        if (pipes != null)
            proTitle.add(pipes);

        return proTitle;
    }

    // assuming crumbs can always be created synchronously
    protected Widget createCrumbs() {
        return null;
    }

    // assuming pipes can always be created synchronously
    protected Widget createPipes() {
        pipesMenu = new PipesMenu(getPipesLinks());
        return pipesMenu;
    }

    protected void selectPipeAction(int selectedIndex) {
        if(pipesMenu != null) {
            pipesMenu.select(selectedIndex);
        }
    }
    
    protected abstract List<PipesMenu.ActionLink> getPipesLinks();

}
