/**
 * Copyright (C) 2006 Lombardi Software
 * http://www.lombardi.com/
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of Lombardi
 * Software ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement and/or Non-Disclosure Agreement you entered into
 * with Lombardi Software. No rights are licenses are granted with respect to
 * the Confidential Information except as expressly set forth in such License
 * Agreement and/or Non-Disclosure Agreement.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL LOMBARDI
 * SOFTWARE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * @author bcampbell
 * @date: Oct 22, 2008
 */
package com.lombardisoftware.gwtcommon.client;

import com.google.gwt.animation.client.Animation;
import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.Element;
import com.google.gwt.user.client.ui.Widget;

public class SlideUpAnimation extends Animation {
    private static final int ANIMATION_DURATION = 350;

    /**
     * Whether the item is being opened or closed.
     */
    private boolean opening = false;

    private Element element;

    public SlideUpAnimation(Widget w){
        this(w.getElement());
    }

    /**
     * @param curElement - the element to fade
     */
    public SlideUpAnimation(Element curElement) {
        this.element = curElement;
    }

    /**
     * Open or close the content.
     *
     * @param panel the panel to open or close
     * @param animate true to animate, false to open instantly
     */
//    public void setOpen(DisclosurePanel panel, boolean animate) {
//      // Immediately complete previous open
//      cancel();
//
//      // Open the new item
//      if (animate) {
//        curPanel = panel;
//        opening = panel.isOpen;
//        run(ANIMATION_DURATION);
//      } else {
//        panel.contentWrapper.setVisible(panel.isOpen);
//      }
//    }

    @Override
    protected void onComplete() {
      if (!opening) {
        //element.setVisible(false);
      }
      DOM.setStyleAttribute(element, "height","auto");
    }

    @Override
    protected void onStart() {
      super.onStart();
      if (opening) {
        //curPanel.contentWrapper.setVisible(true);
      }
    }

    @Override
    protected void onUpdate(double progress) {
      int scrollHeight = DOM.getElementPropertyInt(element, "scrollHeight");
      int height = (int) (progress * scrollHeight);
      if (!opening) {
        height = scrollHeight - height;
      }
      height = Math.max(height, 1);
      DOM.setStyleAttribute(element, "height", height + "px");
      DOM.setStyleAttribute(element, "width", "auto");
    }
}
