package com.lombardisoftware.gwtcommon.client;

import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.user.client.ui.SourcesClickEvents;
import com.google.gwt.user.client.ui.ClickListenerCollection;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.Event;

/**
 * @author tcarpenter
 * @created Jan 9, 2008, 5:27:30 PM
 */
public class Span extends Widget implements SourcesClickEvents {

    ClickListenerCollection clickListeners = null;

    public Span() {
        super();
        setElement(DOM.createSpan());
    }

    public Span(String text) {
        this(text, false);
    }

    public Span(String text, boolean asHTML) {
        this();
        if (asHTML) {
            setHTML(text);
        } else {
            setText(text);
        }
    }

    public void setHTML(String html) {
        DOM.setInnerHTML(getElement(), html);
    }

    public void setText(String text) {
        DOM.setInnerText(getElement(), text);
    }

    public void addClickListener(ClickListener listener) {
        if (clickListeners == null) {
            clickListeners = new ClickListenerCollection();
            sinkEvents(Event.ONCLICK);
        }
        clickListeners.add(listener);
    }

    @Override
    public void onBrowserEvent(Event event) {
        switch (event.getTypeInt()) {
            case Event.ONCLICK:
                if (clickListeners != null) {
                    clickListeners.fireClick(this);
                }
                break;
        }
    }

    public void removeClickListener(ClickListener listener) {
        if (clickListeners != null) {
            clickListeners.remove(listener);
        }
    }
}
