/**
 * 
 */
package com.lombardisoftware.gwtcommon.client;

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.user.client.Timer;

/**
 * @author jsugg
 *
 */
public class TimerRefresher implements IRefresher {

    protected static final int DEFAULT_INTERVAL = 15000;
    
    protected int interval = DEFAULT_INTERVAL;
    protected List<IRefreshListener> listeners = new ArrayList<IRefreshListener>();
    protected Timer timer = null;
    
    public TimerRefresher() {
        super();
    }

    public TimerRefresher(int interval) {
        super();
        this.interval = interval;
    }

    /* (non-Javadoc)
     * @see com.lombardisoftware.repository.client.IRefresher#addListener(com.lombardisoftware.repository.client.IRefreshListener)
     */
    public void addListener(IRefreshListener listener) {
        if (!listeners.contains(listener))
            listeners.add(listener);
    }

    /* (non-Javadoc)
     * @see com.lombardisoftware.repository.client.IRefresher#removeListener(com.lombardisoftware.repository.client.IRefreshListener)
     */
    public void removeListener(IRefreshListener listener) {
        if (listeners.contains(listener))
            listeners.remove(listener);
    }

    public void start() {
        if (timer == null) {
            timer = new Timer() {
                public void run() {
                    timer.cancel();
                    fireListeners(new RefreshEvent());
                    timer.scheduleRepeating(interval);
                }
            };
        } else {
            timer.cancel();
        }
        
        timer.scheduleRepeating(interval);
    }

    protected void fireListeners(RefreshEvent event) {
        for (IRefreshListener listener : listeners ) {
            listener.refresh(event);
        }
    }

    public void stop() {
        timer.cancel();
    }
}
