package com.lombardisoftware.gwtcommon.client;

import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.user.client.ui.ComplexPanel;
import com.google.gwt.user.client.DOM;

/**
 * @author tcarpenter
 * @created Jan 9, 2008, 5:35:45 PM
 */
public class UnorderedListPanel extends ComplexPanel {
    public UnorderedListPanel() {
        super();
        setElement(DOM.createElement("ul"));
    }

    public void addListItem(String text) {
        add(new ListItem(text));
    }

    public void addListItem(String text, String styleName) {
        ListItem li = new ListItem(text);
        CommonUtils.addAutomationId(li, "gwtcommon.client.unorderedListPanel.listItem_0");
        li.setStyleName(styleName);
        add(li);
    }

    public void addListItem(Widget child) {
        child.addStyleName("inline");
        ListItemPanel li = wrapWidget(child);
        
        if (getChildren().size() == 0) {
            li.addStyleName("firstElement");
        }
        
        add(li);
    }

    public void addListItem(Widget child, String styleName) {
        child.addStyleName("inline");
        ListItemPanel li = wrapWidget(child);
        li.setStyleName(styleName);
        
        if (getChildren().size() == 0) {
            li.addStyleName("firstElement");
        }
        
        add(li);
    }

    public void applyStyle(int index, String styleName) {
        Widget li = getWidget(index);
        li.setStyleName(styleName);
    }
    
    public void addHtmlListItem(String html) {
        ListItem li = new ListItem();
        CommonUtils.addAutomationId(li, "gwtcommon.client.unorderedListPanel.listItem_1");
        li.setHTML(html);
        add(li);
    }

    public void addHtmlListItem(String html, String styleName) {
        ListItem li = new ListItem();
        CommonUtils.addAutomationId(li, "gwtcommon.client.unorderedListPanel.listItem_2");
        li.setStyleName(styleName);
        li.setHTML(html);
        add(li);
    }

    public void add(Widget child) {
        super.add(child, getElement());
    }

    public void insert(Widget child, int index) {
        wrapWidget(child);
        super.insert(child, getElement(), index, true);
    }

    private ListItemPanel wrapWidget(Widget child) {
        ListItemPanel nestedPanel = new ListItemPanel();
        CommonUtils.addAutomationId(nestedPanel, "gwtcommon.client.unorderedListPanel.listItemPanel_" + child.getTitle());
        nestedPanel.add(child);
        return nestedPanel;
    }

}
