package com.lombardisoftware.gwtcommon.client.clientObjects;

import java.io.Serializable;

/**
 * ClientPermission contains a subset/translation of the TWPermission class. 
 *
 * @see com.lombardisoftware.server.ejb.security.TWPermission
 * @author zroadhouse
 *
 */
public enum ClientPermission implements Serializable {

    /**
     * Read access
     */
	READ,

	/**
	 * Write access
	 */
	WRITE,

	/**
	 * Administration access
	 */
	ADMINISTRATION;

    @Override
    public String toString() {
        switch(this) {
            case ADMINISTRATION: return "ADMIN";
            case WRITE: return "WRITE";
            default: return "READ";
        }
    }

}