/*
 * Copyright (C) 2009 Lombardi Software
 * http://www.lombardi.com/
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of Lombardi
 * Software ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement and/or Non-Disclosure Agreement you entered into
 * with Lombardi Software. No rights are licenses are granted with respect to
 * the Confidential Information except as expressly set forth in such License
 * Agreement and/or Non-Disclosure Agreement.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL LOMBARDI
 * SOFTWARE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.lombardisoftware.gwtcommon.client.help;

import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.Element;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.dom.client.Document;
import com.google.gwt.dom.client.Text;
import com.google.gwt.dom.client.DivElement;

import com.lombardisoftware.gwtcommon.client.help.HelpTopicProvider;

/**
 * The widget to display information in the right-bottom Repository panel
 * and link help topics to Repository tabs and pages.
 *
 * @author Slava Nadvorny vnadvorny
 */
class HelpWidget extends Widget {

    protected HelpWidget(HelpTopicProvider provider) {

        setElement(DOM.createDiv());
        Element title = DOM.createElement("h1");
        getElement().appendChild(title);
        getElement().setClassName("helpWidget");

        DivElement icon = Document.get().createDivElement();
        icon.setClassName("questionMarkHelpIcon");
        icon.setTitle("Information");
        title.appendChild(icon);

        Text titleText = Document.get().createTextNode(provider.getInformationTitle());
        title.appendChild(titleText);

        // Information may contain HTML.
        Element informationBlock = DOM.createDiv();
        informationBlock.setInnerHTML(provider.getInformationContent());
        getElement().appendChild(informationBlock);
    }

}
