package com.lombardisoftware.gwtcommon.client.i18n;

import java.util.MissingResourceException;

import com.google.gwt.i18n.client.Dictionary;
import com.lombardisoftware.gwtcommon.client.util.MessageFormat;

public class Messages {

	private Dictionary messages = null;
	private Dictionary defaultMessages = null;

	public Messages(String bundleObjectName, String defaultBundleObjectName) {
		messages = Dictionary.getDictionary(bundleObjectName);
		if (defaultBundleObjectName != null) {
			defaultMessages = Dictionary.getDictionary(defaultBundleObjectName);
		}
	}

	public String getString(String key) {
		return doGetString(key, null);
	}

	public String getString(String key, Object... args) {
		return doGetString(key, args);
	}

	private String doGetString(String key, Object[] args) {
		String value = null;
		try {
			value = messages.get(key);
		} catch (MissingResourceException ex) {
			if (defaultMessages != null) {
				try {
					value = defaultMessages.get(key);
				} catch (MissingResourceException ex2) {
					// normally, should not happen.
				}
			}
		}
		if (value != null && (args != null && args.length != 0)) {
			value = MessageFormat.format(value, args);
		}
		if (value == null) {
			value = "$$" + key + "$$";  
		}
		return value;
	}
}
