package com.lombardisoftware.gwtcommon.client.preferences;

import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.List;

/**
 * Pure data object for
 */
public class PreferencesDataObject implements Serializable {

    /** For GWT serialization */
    public PreferencesDataObject() { }

    private List<DisplayLocale> supportedLocales;

    private LinkedHashMap<UserPreferences.PropertyName, Preference> prefsMap = new LinkedHashMap<UserPreferences.PropertyName, Preference>();

    public List<DisplayLocale> getSupportedLocales() {
        return supportedLocales;
    }

    public void setSupportedLocales(List<DisplayLocale> supportedLocales) {
        this.supportedLocales = supportedLocales;
    }

    public LinkedHashMap<UserPreferences.PropertyName, Preference> getPrefsMap() {
        return prefsMap;
    }

    public void putPreference(UserPreferences.PropertyName name, String initialValue) {
        prefsMap.put(name, new Preference(initialValue));
    }

    public String getPreferenceValue(UserPreferences.PropertyName name) {
        return prefsMap.get(name).getValue();
    }


}
