@echo off & setlocal ENABLEEXTENSIONS


SETLOCAL
set CLIENT_JAVA_HOME=~JVM~

if ["%CLIENT_JAVA_HOME%"]==[] goto :NoClientJavaHome
if not exist "%CLIENT_JAVA_HOME%" goto :NoClientJavaHome

if not exist "%CLIENT_JAVA_HOME%" goto :NoClientJavaBits
if not exist "%CLIENT_JAVA_HOME%\bin" goto :NoClientJavaBits
if not exist "%CLIENT_JAVA_HOME%\bin\java.exe" goto :NoClientJavaBits

:setVarsToNull
rem make sure that those variables does not have values 
set CLASS_PATH=.;resources;lib/psclnt.jar;lib/commons-httpclient.jar;lib/commons-httpclient-contrib.jar;lib/langutil.jar;lib/svrcoreclnt.jar;lib/log4j.jar
set CLASS_PATH=%CLASS_PATH%;lib/commons-logging.jar;lib/utility.jar;lib/commons-codec.jar;lib/xbean.jar;lib/jdom.jar;lib/castor.jar
set EXTRA_JAVA_OPTION=
set HOST=NULL
set PORT=NULL
set USERNAME=NULL
set PASSWORD=NULL

:processSpecialArguments 
if %1 == --host set HOST=%2 && shift && shift && goto processSpecialArguments
if %1 == -h set HOST=%2 && shift && shift && goto processSpecialArguments
if %1 == --port set PORT=%2 && shift && shift && goto processSpecialArguments
if %1 == -t set PORT=%2 && shift && shift && goto processSpecialArguments
if %1 == --username set USERNAME=%2 && shift && shift && goto processSpecialArguments
if %1 == -u set USERNAME=%2 && shift && shift && goto processSpecialArguments
if %1 == --password set PASSWORD=%2 && shift && shift && goto processSpecialArguments
if %1 == -p set PASSWORD=%2 && shift && shift && goto processSpecialArguments
if %1 == --debug set EXTRA_JAVA_OPTION=-Xnoagent -Xdebug -Xrunjdwp:transport=dt_socket,server=y,address=12008,suspend=n && shift && goto processSpecialArguments
if %1 == --help goto help
if %1 == -? goto help
goto go

:go
set PATH=%PATH%;lib

set JAVA_ARGS=-Xmx512m
set JAVA_ARGS=%JAVA_ARGS% -Dteamworks.applicationServerPlatform="WebSphere 6.1" -classpath %CLASS_PATH%
set JAVA_ARGS=%JAVA_ARGS% -Dhost=%HOST% -Dport=%PORT% -Dusername=%USERNAME% -Dpassword=%PASSWORD% -Dfilename=%1 -Dstate=%2
set JAVA_ARGS=%JAVA_ARGS% %EXTRA_JAVA_OPTION%

"%CLIENT_JAVA_HOME%\bin\java" %JAVA_ARGS% com.lombardisoftware.processinstaller.client.InstallProcessAppPackageTool 
goto end

:NoClientJavaHome
echo CLIENT_JAVA_HOME is not correctly set. process-installers tools require Java.
goto :end

:NoClientJavaBits
echo Java could not be found in %CLIENT_JAVA_HOME%. process-installers tools require Java.
goto :end

:help
echo Usage: _internalInstallPackage [options...] ^<package name^> [PackageInstalled , InstallationServiceExecuted , GlobalAssetMigrated , InstancedMigrated]
echo Options:
echo   -?, --help                             print this message
echo   -h ^<host^>, --host ^<host^>               the host of the process center server where the snapshot is taken
echo   -t ^<port^>, --port ^<port^>               the port of the process center server where the snapshot is taken
echo   -u ^<username^>, --username ^<username^> 	 username of the Teamworks administrator
echo   -p ^<password^>, --password ^<password^> 	 user password (unencrypted)
goto end

:end
exit /B %ERRORLEVEL%