#!/bin/sh

usage() {
	echo "Usage: _internalInstallPackage.sh [options...] <package name> [PackageInstalled , InstallationServiceExecuted , GlobalAssetMigrated , InstancedMigrated]" 
	echo "Options:"
	echo "	-?, --help                             print this message"
	echo "	-h <host>, --host <host>               the host of the process center server where the snapshot is taken"
	echo "	-t <port>, --port <port>               the port of the process center server where the snapshot is taken"
	echo "	-u <username>, --username <username>   username of the Teamworks administrator"
	echo "	-p <password>, --password <password>   user password (unencrypted)"
  exit 0  
}

if [ "$1" = "--help" -o "$1" = "-?" ]; then
   usage
fi

CLIENT_JAVA_HOME=~JVM~

if [ ! -d $CLIENT_JAVA_HOME ]; then
  echo "$CLIENT_JAVA_HOME is not correctly set. retrieveProcessAppPackage.sh requires a Java VM."
  exit 1
fi

if [ ! -f $CLIENT_JAVA_HOME/bin/java ]; then
  echo "Java could not be found in $CLIENT_JAVA_HOME/bin. retrieveProcessAppPackage.sh requires a Java VM."
  exit 1
fi

#
# Setting default values
#

HOST="NULL"
PORT="NULL"
USERNAME="NULL"
PASSWORD="NULL"

FINISHED='0'
java_args=
until [ "$#" = "1" -o "$#" = "0" -o $FINISHED = '1' ]
do
  case "$1" in            
      '--host')
          HOST="$2"
          shift;shift
          ;;
	  '-h')
          HOST="$2"
          shift;shift
          ;; 	          
      '--port')
          PORT="$2"
          shift;shift
          ;;
		'-t')
          PORT="$2"
          shift;shift
          ;;          
        '--username')
          USERNAME="$2"
          shift;shift
          ;;
        '-u')
          USERNAME="$2"
          shift;shift
          ;;  
		'--password')
          PASSWORD="$2"
          shift;shift
          ;;
        '-p')
          PASSWORD="$2"
          shift;shift
          ;;            
        '--debug')
          java_args="-Xnoagent -Xdebug -Xrunjdwp:transport=dt_socket,server=y,address=12008,suspend=n"
          shift
          ;;
      *)
          FINISHED='1'
          ;;
  esac
done

java_args="$java_args -Xmx512m"
java_args="$java_args -Dteamworks.applicationServerPlatform=\"WebSphere 6.1\" -classpath .:resources:lib/psclnt.jar:lib/commons-httpclient.jar:lib/commons-httpclient-contrib.jar:lib/langutil.jar"
java_args="$java_args:lib/svrcoreclnt.jar:lib/log4j.jar:lib/commons-logging.jar:lib/utility.jar:lib/commons-codec.jar:lib/xbean.jar:lib/jdom.jar:lib/castor.jar"
java_args="$java_args -Dhost=$HOST -Dport=$PORT -Dusername=$USERNAME -Dpassword=$PASSWORD -Dfilename=$1 -Dstate=$2"

java_cmd="$CLIENT_JAVA_HOME/bin/java $java_args com.lombardisoftware.processinstaller.client.InstallProcessAppPackageTool "
#echo $java_cmd
eval $java_cmd
