<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.repository.server.RepositoryServicesUtils"%>
<%@ page import="com.lombardisoftware.core.UserLocalePreferences" %>
<%@ page import="java.util.Locale" %>
<%@ page import="com.lombardisoftware.utility.i18n.LocaleUtils" %>
<%
    // Debug locale override.
	String locale = request.getParameter("locale");
	if (locale == null) {

        // If user does not have locale prefs save it to
        UserLocalePreferences userLocalePrefs = RepositoryServicesUtils.getCurrentUserLocalePreferences();
        if (userLocalePrefs.isFallback()) {

            Locale matching = LocaleUtils.findMatching(LocaleUtils.getInstalledLocales(), request.getLocales());
            RepositoryServicesUtils.setCurrentUserLocalePreferences(matching.toString());
            locale = matching.toString();
        } else {
            // If user has locale pref -- use it and set cookies to it.
            locale = userLocalePrefs.getLocale();
        }
        LocaleUtils.saveLocaleToCookies(locale, response);

	}
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html style="overflow: hidden">
    <head>
        <title>WebSphere Lombardi Edition Process Center</title>
        <meta http-equiv="content-type" content="text/html; charset=UTF-8">
		<% 	if (locale != null) { %>
    	<meta name="gwt:property" content="locale=<%= locale %>"> <%
    		}
    	%>
        <link rel="stylesheet" type="text/css" href="GwtCommon.css" />
        <link rel="stylesheet" type="text/css" href="Repository.css" />
        <!--[if lt IE 7]>
            <link rel="stylesheet" type="text/css" href="ie6repository.css" />
            <script>
                try {
                  document.execCommand("BackgroundImageCache", false, true);
                } catch(err) {}
            </script>
        <![endif]--> 
    </head>
    <script language="JavaScript" type="text/javascript">
        var wle_gwt_i18n_CommonMessages = <%= RepositoryServicesUtils.getClientResourceBundleContent("CommonMessages", locale) %>;
        var wle_gwt_i18n_RepositoryMessages = <%= RepositoryServicesUtils.getClientResourceBundleContent("RepositoryMessages", locale) %>;
        var wle_gwt_i18n_HelpMessages = <%= RepositoryServicesUtils.getClientResourceBundleContent("HelpMessages", locale) %>;
        var wle_gwt_i18n_CommonMessages_default = <%= RepositoryServicesUtils.getClientResourceBundleContent("CommonMessages", "en") %>;
        var wle_gwt_i18n_RepositoryMessages_default = <%= RepositoryServicesUtils.getClientResourceBundleContent("RepositoryMessages", "en") %>;
        var wle_gwt_i18n_HelpMessages_default = <%= RepositoryServicesUtils.getClientResourceBundleContent("HelpMessages", "en") %>;

        var TW = {
            pageData :{
                contextPath: '<%= request.getContextPath() %>'    
            }
        };
    </script>
    <body>
        <script language="javascript" src="com.lombardisoftware.repository.Repository.nocache.js"></script>
    </body>
</html>
