<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.servlet.exceptions.LswTagException,
                 com.lombardisoftware.core.config.TWConfiguration" %>
<%@ include file="html/common/prolog.jsp" %>
<%@ include file="html/msgs-init.jsp" %>
<html>
<head>
<title><bean:message key="process_server.login.title" /></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/login.css" TYPE="text/css">
<%@ include file="html/common/javascript.jsp" %>
<script>

    //  If login page opened in frame reload parent.
    if (window.parent != window.self) {
        window.parent.location.reload();
    }

    setCookie("taskid", "-1");
    setCookie("folderid", "1");
    setCookie("filter", "off");
    setCookie("screen", "detail");
    deleteCookie("filter_datefrom");
    deleteCookie("filter_dateto");
    deleteCookie("filter_sentby");
    deleteCookie("filter_priority");
    deleteCookie("filter_predefined");
    deleteCookie("filter_subject");
    deleteCookie("filter_category");
    deleteCookie("filter_category_virtual");

    deleteCookie("LTPACookie");

	// Teamworks task manager and console are frames based
	// If the session times out, we want the browser to show
	// the login page in the top level frame (as long as that
	// frame is hosted by Teamworks)
    if (top != self) {
        try {
            var pos = top.location.indexOf("/teamworks");
            if (pos != -1 && top.location.substring(0, pos) == self.location.substring(0, pos)) {
                top.location.reload();
            }
        } catch(e) {
            // you can't access 'top' properties from 'iframe' due to security reasons
        }
    }

    var allowSubmit = false;

    /** Detect if browser is IE */
    function /* Boolean */ isIE() {
        return navigator.userAgent.indexOf("MSIE") >= 0;
    }

    function doOnSubmit() {
        <%--We want to make sure the applet has been loaded before we log in so that we can get the correct locale/time zone info from the client. If all else fails we assume GMT...--%>
        if (!allowSubmit) {
            window.status = '<bean:message key="process_server.login.window.status"/>';
            return false;
        }

        var module = "";
        var objModule = document.getElementById("module");
        if (objModule != null)
            module = objModule.value;
        document.login.j_username.value = module + document.login.username.value;

		setCookie("timezoneOffset", new Date().getTimezoneOffset(), null, "/");
        return true;
    }

    function doOnLoad() {
<%
        if(request.getParameter("zMessage") == null) {
%>
        if (getCookie("username") == 'null' || !getCookie("username")) {
            document.login.username.focus();
        }
        else {
            document.login.username.value = getCookie("username");
            if (document.login.module != null)
                document.login.module.value = getCookie("module");
            document.login.j_password.focus();
        }
<%
        }
%>
        if (isIE()) {
            var autologinDiv = document.getElementById("autologinLink");
            if (autologinDiv != null) {
                autologinDiv.style.visibility = "visible";
            }
        }

        allowSubmit = true;
    }
</script>
</head>

<body onLoad="doOnLoad()">

<div id="login-header">
        <div class="logo"></div>
</div>

<lsw:IncludeFile zFile="login-mod.inc"/>

        <table cellpadding="0" cellspacing="0" width="100%">
            <tr>
                <td>&nbsp;</td>
                <td width="500">
                    <div id="login-content">
                        <table id="content-header" cellspacing="0" cellpadding="0">
                            <tr>
                                <td id="content-header-left"></td>
                                <td id="content-header-right"></td>
                            </tr>
                        </table>
                        <%
                            String msgKey = request.getParameter("zMessage");
                            if (msgKey == null) {
                                msgKey = (String) session.getAttribute("zMessage");
                            }
                        %>
                        <%if (msgKey != null) {%>
                            <div id="login-error">
                                <bean:message key="<%=msgKey%>"/>
                            </div>
                        <%}%>
                        <div id="JavaScriptWarning"><bean:message key="process_server.login.javascript.warn"/></div>
                        <script>
                            var id = document.getElementById("JavaScriptWarning");
                            id.innerHTML = "";
                        </script>
                        <form method="POST" action="j_security_check" name="login" onSubmit="return doOnSubmit()">
                            <input type="hidden" name="j_uri" value="tm_taskmanager.lsw">
                            <input type="hidden" name="zTimeZone" value="GMT">
                            <input type="hidden" name="zTimeZoneOffset" value="0">
                            <input type="hidden" name="zLocaleCountry" value="US">
                            <input type="hidden" name="zLocaleLanguage" value="en">
                            <input type="hidden" name="zPost" value="1">
                            <input type="hidden" name="j_username">
                        <%
                            if (request.getParameter("zTaskId") != null) {
                        %>
                            <input type="hidden" name="zTaskId" value="<%= request.getParameter("zTaskId") %>">
                            <input type="hidden" name="zSaveParam" value="zTaskId">
                        <%
                            }

                            if (request.getParameter("zDirect") != null) {
                        %>
                            <input type="hidden" name="zDirect" value="1">
                            <input type="hidden" name="zSaveParam" value="zDirect">
                        <%
                            }
                        %>
                            <div>
                                <table id="login-table" align="center">
                                    <tr>
                                        <td><bean:message key="process_server.login.user.name"/></td>
                                        <td><input style="width:130" type="text" name="username"></td>
                                    </tr>
                                    <tr>
                                        <td><bean:message key="process_server.login.user.password"/></td>
                                        <td><input style="width:130" type="password" name="j_password"></td>
                                    </tr>
                                    <tr>
                                        <td colspan="2" align="center"><input type="submit" value="<bean:message key="process_server.login"/>"></td>
                                    </tr>
                                    <%
                                        if (TWConfiguration.getInstance().getServer().isShowAutologinLink()) {
                                            // TODO: "Auto-login..." should be localized
                                            %><tr><td colspan="2" align="center"><div id="autologinLink" style="visibility:hidden"><a href="/teamworks/autoLogin.jsp?sp=/teamworks/cs_main.lsw">Auto-login using my Windows credentials</a></div></td></tr><%
                                        }
                                    %>
                                </table>
                                <div id="login-copyright"><bean:message key="process_server.copyright"/></div>
                            </div>
                        </form>
                        <table id="content-footer" cellspacing="0" cellpadding="0">
                            <tr>
                                <td id="content-footer-left"></td>
                                <td id="content-footer-right"></td>
                            </tr>
                        </table>
                    </div>
                </td>
                <td>&nbsp;</td>
            </tr>
        </table>
    </div>
</body>
</html>
