<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.core.TWHttpClient,
                 com.lombardisoftware.core.config.TWConfiguration,
                 com.lombardisoftware.utility.ApplicationServerPlatform,
                 com.lombardisoftware.utility.Base64Encoder,
                 com.lombardisoftware.core.TeamWorksRuntimeException,
                 java.net.URLEncoder" %>
<%
	String username = null;
	String password = null;
    if (TWConfiguration.getInstance().getAuthoringEnvironment().isAddRedirectUrlCredentials()) {
        if (TWConfiguration.getInstance().getAuthoringEnvironment().isEncodeRedirectUrlCredentials()) {
			String credentials = request.getParameter("credentials");
			if (credentials != null) {
			    int pos = credentials.indexOf(":");
			    try {
			        username = new String(Base64Encoder.base64ToByteArray(credentials.substring(0, pos)), "UTF-8");
			        password = new String(Base64Encoder.base64ToByteArray(credentials.substring(pos + 1)), "UTF-8");
			    } catch(java.io.UnsupportedEncodingException e) {
			    	throw TeamWorksRuntimeException.asTeamWorksRuntimeException(e);
			    }
		    }
        } else {
		    username = request.getParameter("j_username");
		    password = request.getParameter("j_password");
        }
    }

    if (ApplicationServerPlatform.JBOSS405.equals(ApplicationServerPlatform.valueOfFromProperty())) {

	    String redirectTo = request.getParameter("j_forward");
	    if (redirectTo != null) {
            redirectTo = redirectTo.replace('|', '&');
            
	        // Add redirect cookie
	        Cookie cookie = new Cookie("TWforwardPage", redirectTo);
	        response.addCookie(cookie);
	    }

	    // This works under JBoss. You cannot directly reference the login page or j_security_check in JBoss. You must
	    // access a secured resource and let the container use the standard mechanism to redirect you to be authenticated.
	    // We use TWHttpClient to do this and then add the session cookie into our current session response.
	    TWHttpClient httpClient = new TWHttpClient(TWConfiguration.getInstance().getAuthoringEnvironment().getImagesPrefix(), username, password);
	    if ((username != null) || (password != null))
		    httpClient.login();
	    
	    org.apache.commons.httpclient.Cookie[] cookies = httpClient.getCookies();
	    if (cookies != null) {
		    for (int i = 0; i < cookies.length; i++) {
		        org.apache.commons.httpclient.Cookie cookie = cookies[i];
				// Need to add ALL cookies that begin with JSESSIONID. With JBoss we will have others such as JSESSIONIDSSO defined
		        if ((cookie != null) && (cookie.getName().startsWith("JSESSIONID") || cookie.getName().equals("LtpaToken"))) {
		            // System.out.println("Found session cookie -- " + cookie);
		            javax.servlet.http.Cookie servletCookie = new javax.servlet.http.Cookie(cookie.getName(), cookie.getValue());
		            // We want these cookies at the root level not /teamworks or /portal
		            servletCookie.setPath("/");
		            response.addCookie(servletCookie);
		        }
		    }
	    }
	    response.sendRedirect("/teamworks/"+redirectTo);

    } else {

	    String redirectTo = request.getParameter("j_forward");
	    if (redirectTo != null) {
	        redirectTo = redirectTo.replace('|', '&');
	        if (redirectTo.startsWith("/")) {
	            redirectTo = "/teamworks" + redirectTo;
	        } else {
	            redirectTo = "/teamworks/" + redirectTo;
	        }
	        
	        // If we are going to download managed asset
	        // we need to encode filename which may contain international symbols
	        if (redirectTo.contains("webasset/")) {
	        	int slashpos = redirectTo.lastIndexOf("/");
	        	if (slashpos > -1 && slashpos < redirectTo.length() - 1) {
	        		String filename = redirectTo.substring(slashpos + 1);
	        		redirectTo = redirectTo.substring(0, slashpos + 1) + URLEncoder.encode(filename, "UTF-8");
	        	}
	        } 
			
			// Add redirect cookie
			Cookie cookie = new Cookie("TWforwardPage", redirectTo);
			response.addCookie(cookie);
	    }

	    Cookie [] cookies = request.getCookies();
	    if (cookies != null) {
		    for (int i = 0; i < cookies.length; i++) {
		        Cookie cookie = cookies[i];
		        if ((cookie != null) && cookie.getName().equals("JSESSIONID")) {
		            // System.out.println("Found JSESSION cookie -- " + cookie + ". Cleaning it out");
		            cookie.setMaxAge(0);
		            response.addCookie(cookie);
		        }
		    }
	    }
	    response.setHeader("Cache-Control", "no-cache, no-store");	    
	    if ((username != null) || (password != null)) {
%>
<html>
    <head>
        <title>Redirect Login</title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    </head>
    <body onLoad="document.login.submit()">
        <form method="POST" action="j_security_check" name="login">
	        <input type="hidden" name="j_username" value="<%= username %>">
	        <input type="hidden" name="j_password" value="<%= password %>">
        </form>
    </body>
</html>
<%
            } else {
	    		response.sendRedirect(redirectTo);
            }
    }
%>
