#!/bin/sh

usage() {
echo Usage: deploy_lombardi.cmd [options]
echo where options include:
echo "    -conntype <[NONE]|SOAP|RMI>   SOAP, RMI or NONE; if you specified connttype"
echo "                                  as SOAP, RMI."
echo "        -host <hostname>          The hostname of the remote server if conntype"
echo "                                  is SOAP or RMI."
echo "        -port <port>              The port number of the remote server if"
echo "                                  conntype is SOAP or RMI."
echo "        -user <username>          The username used to authenticate with the"
echo "                                  remote server to deploy applications."
echo "        -password <password>      The password used to authenticate with the"
echo "                                  remote server to deploy applications."
echo "    -auser <app_username>         Application username which is used as RunAs"
echo "                                  user in the Lombardi server applications,"
echo "                                  default tw_admin."
echo "    -apassword <app_password>     Application password which is used as RunAs"
echo "                                  password in the Lombardi server applications,"
echo "                                  default tw_admin."
}

CONNTYPE=NONE
CONNTYPE_EXTRA=
USERNAME=~TW_USER~
PASSWORD=~TW_PASSWORD~

while [ $# -gt 0 ]
do
  case "$1" in
    -conntype)
      CONNTYPE="$2"
      shift
      ;;
    -host)
      CONNTYPE_EXTRA="$CONNTYPE_EXTRA $1 $2"
      shift
      ;;
    -port)
      CONNTYPE_EXTRA="$CONNTYPE_EXTRA $1 $2"
      shift
      ;;
    -user)
      CONNTYPE_EXTRA="$CONNTYPE_EXTRA $1 $2"
      shift
      ;;
    -password)
      CONNTYPE_EXTRA="$CONNTYPE_EXTRA $1 $2"
      shift
      ;;
    -auser)
      USERNAME="$2"
      shift
      ;;
    -apassword)
      PASSWORD="$2"
      shift
      ;;
    *)
      usage
      exit
  esac
  shift
done

TW_INSTALL_DIR=~DEPLOY_DIR~
. $TW_INSTALL_DIR/../bin/setEnv.sh

# Directory where your WebSphere Application Server or Network Deployment is installed
WAS_HOME=$APPSERVER_HOME

WAS_BIN_HOME=$WAS_HOME/profiles/$WAS_PROFILE/bin
if [ "${TEAMWORKS_IS_ND:=}" = "true" ]
then
  WAS_BIN_HOME=$WAS_HOME/profiles/$WAS_DMGR_PROFILE/bin
fi

TW_CELL=$PROCESS_SRV_CELL

# The node that the process server is going to be deployed in
TW_NODE=$PROCESS_SRV_NODE

TW_SERVER=$TEAMWORKS_PROCESS_SRV

TW_CLUSTER=${TW_SERVER}_cluster

# The virtual host for the process server
TW_VIRTUAL_HOST=${TW_SERVER}_host

$WAS_BIN_HOME/wsadmin.sh -conntype $CONNTYPE $CONNTYPE_EXTRA -f $TW_INSTALL_DIR/bin/application_teamworks.py $TW_CELL $TW_NODE $TW_SERVER $TW_VIRTUAL_HOST $TW_INSTALL_DIR $TW_CLUSTER $TEAMWORKS_IS_ND $USERNAME $PASSWORD

echo "Deploy completed"
