@echo off

set CONNTYPE=NONE
set CONNTYPE_EXTRA=
set USERNAME=~TG_USER~
set PASSWORD=~TG_PASSWORD~

:setupArgs
if "%1" == "" goto doneArgs

if not "%1" == "-conntype" goto endif4
shift
set CONNTYPE=%1
shift
goto setupArgs
:endif4

if not "%1" == "-host" goto endif5
set CONNTYPE_EXTRA=%CONNTYPE_EXTRA% %1
shift
set CONNTYPE_EXTRA=%CONNTYPE_EXTRA% %1
shift
goto setupArgs
:endif5

if not "%1" == "-port" goto endif6
set CONNTYPE_EXTRA=%CONNTYPE_EXTRA% %1
shift
set CONNTYPE_EXTRA=%CONNTYPE_EXTRA% %1
shift
goto setupArgs
:endif6

if not "%1" == "-user" goto endif7
set CONNTYPE_EXTRA=%CONNTYPE_EXTRA% %1
shift
set CONNTYPE_EXTRA=%CONNTYPE_EXTRA% %1
shift
goto setupArgs
:endif7

if not "%1" == "-password" goto endif8
set CONNTYPE_EXTRA=%CONNTYPE_EXTRA% %1
shift
set CONNTYPE_EXTRA=%CONNTYPE_EXTRA% %1
shift
goto setupArgs
:endif8

if not "%1" == "-auser" goto endif9
shift
set USERNAME=%1
shift
goto setupArgs
:endif9

if not "%1" == "-apassword" goto endif10
shift
set PASSWORD=%1
shift
goto setupArgs
:endif10

goto error

:doneArgs

setlocal

set TW_INSTALL_DIR=~DEPLOY_DIR~
set TW_INSTALL_DIR_UNIX=~DEPLOY_DIR_UNIX~
call "%TW_INSTALL_DIR%\..\bin\setEnv.cmd"

rem Directory where your WebSphere Application Server or Network Deployment is installed
set WAS_HOME=%APPSERVER_HOME%

set WAS_BIN_HOME=%WAS_HOME%/profiles/%WAS_PROFILE%/bin
if %TEAMWORKS_IS_ND% NEQ true goto noDmgr
  set WAS_BIN_HOME=%WAS_HOME%/profiles/%WAS_DMGR_PROFILE%/bin
:noDmgr

rem The cell that the performance server is going to be deployed in
set TW_CELL=%PERF_SRV_CELL%

rem The node that the performance server is going to be deployed in
set TW_NODE=%PERF_SRV_NODE%

set TW_SERVER=%TEAMWORKS_PERF_SRV%

set TW_CLUSTER=%TW_SERVER%_cluster

rem The virtual host for the performance server
set TW_VIRTUAL_HOST=%TW_SERVER%_host

set PATH=%PATH%;%WAS_BIN_HOME%

call wsadmin -conntype %CONNTYPE% %CONNTYPE_EXTRA% -f "%TW_INSTALL_DIR_UNIX%/bin/deploy_performance_server.py" %TW_CELL% %TW_NODE% %TW_SERVER% "%TW_VIRTUAL_HOST%" "%TW_INSTALL_DIR_UNIX%/applications/twperfsvr.ear" %TW_CLUSTER% %TEAMWORKS_IS_ND% %USERNAME% %PASSWORD%

endlocal

echo "Deploy completed"

goto end

:error
echo Usage: deploy_performance_server.cmd [options]
echo where options include:
echo     -conntype ^<[NONE]^|SOAP^|RMI^>   SOAP, RMI or NONE; if you specified connttype
echo                                   as SOAP, RMI.
echo        -host ^<hostname^>           The hostname of the remote server if conntype 
echo                                   is SOAP or RMI.
echo        -port ^<port^>               The port number of the remote server if
echo                                   conntype is SOAP or RMI.
echo        -user ^<username^>           The username used to authenticate with the
echo                                   remote server to deploy applications.
echo        -password ^<password^>       The password used to authenticate with the
echo                                   remote server to deploy applications.
echo    -auser ^<app_username^>          Application username which is used as RunAs
echo                                   user in the performance data warehouse
echo                                   applications, default tw_user.
echo    -apassword ^<app_password^>      Application password which is used as RunAs
echo                                   password in the performance data warehouse
echo                                   applications, default tw_user.
goto end

:end
